---------
function GoGo_OnLoad()
---------
	SLASH_GOGOMOUNT1 = "/gogo"
	SlashCmdList["GOGOMOUNT"] = function(msg) GoGo_OnSlash(msg) end
	SLASH_GOGOID1 = "/id"
	SlashCmdList["GOGOID"] = function(msg) GoGo_Msg(GoGo_Id(msg)) end
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("UPDATE_BINDINGS")
	this:RegisterEvent("TAXIMAP_OPENED")
	this:RegisterEvent("CHAT_MSG_ADDON")

end --function

---------
function GoGo_OnEvent(event)
---------
	if event == "VARIABLES_LOADED" then
		TESTVERSION = true
		GOGO_DEBUG = false
		if not GoGo_Prefs then
			GoGo_Prefs = {checkspells = true, autodismount = true, preferflight = true}
		end --if
		if GoGo_Prefs.autodismount then
			this:RegisterEvent("UI_ERROR_MESSAGE")
		end --if
		_, GOGO_CLASS = UnitClass("player")
		if GOGO_SPELLS[GOGO_CLASS] then
			this:RegisterEvent("PLAYER_REGEN_DISABLED")
		end --if
		if (GOGO_CLASS == "DRUID" or GOGO_CLASS == "SHAMAN") then
			GoGoFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
			GoGoFrame:SetScript("OnUpdate", GoGo_CheckMoving)
		end --if
		GOGO_OUTLANDS = table.concat({GetMapZones(3)}, ":")..":"..GOGO_TWISTING_NETHER
		GOGO_NORTHREND = table.concat({GetMapZones(4)}, ":")
		if not GoGo_Prefs.version or GoGo_Prefs.version ~= GetAddOnMetadata("GoGoMount", "Version") then
			GoGo_Settings_Default()
		end --if
		GoGo_Settings_Update()
	elseif event == "PLAYER_REGEN_DISABLED" then
		for i, button in ipairs({GoGoButton, GoGoButton2}) do
			if GoGo_Prefs.checkspells then
				GoGo_FillButton(button, GoGo_ChooseMount(GOGO_SPELLS))
			else
				GoGo_FillButton(button)
			end --if
		end --for
	elseif event == "ZONE_CHANGED_NEW_AREA" then
		SetMapToCurrentZone()
	elseif event == "TAXIMAP_OPENED" then
		GoGo_Dismount()
	elseif event == "UPDATE_BINDINGS" then
		GoGo_CheckBindings()
	elseif event == "UI_ERROR_MESSAGE" then
		if GOGO_ERRORS[arg1] and not IsFlying() then
			GoGo_Dismount()
		end --if
	elseif (event == "CHAT_MSG_ADDON") and (arg1 == "GoGoMountVER") and not GoGo_Prefs.DisableUpdateNotice then
		if (arg2 > GetAddOnMetadata("GoGoMount", "Version")) and not GoGoShownUpdate then
			GoGoShownUpdate = true
			DEFAULT_CHAT_FRAME:AddMessage("** GoGoMount update is available and is being used by "..arg4)
		end --if
	end --if
end --function

---------
function GoGo_OnSlash(msg)
---------
	if GOGO_COMMANDS[string.lower(msg)] then
		GOGO_COMMANDS[string.lower(msg)]()
	elseif string.find(msg, "spell:%d+") then
		if GoGo_InCompanions(msg) then
			GoGo_AddPrefMount(msg)
			GoGo_Msg("pref")
--		elseif GoGo_InBook(msg) then
--			GoGo_AddPrefSpell(msg)
--			GoGo_Msg("pref")
		else
			GoGo_Msg("spell")
			GoGo_Msg("auto")
			GoGo_Msg("fly")
			GoGo_Msg("pref")
			GoGo_Msg("disableupdatenotice")
			GoGo_Msg("The linked mount was not found in your list of mounts.")
			if GOGO_DEBUG then
				DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Valid spell link but was not found in spell book or mount store."))
			end --if
		end --if
	else
		GoGo_Msg("spell")
		GoGo_Msg("auto")
		GoGo_Msg("fly")
		GoGo_Msg("pref")
		GoGo_Msg("disableupdatenotice")
	end --if
end --function

---------
function GoGo_PreClick(button)
---------
	if GOGO_DEBUG then
		DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("GoGo PreClick Runs"))
	end --if

	if not InCombatLockdown() then
		GoGo_FillButton(button)
	end --if

	if IsMounted() then
		GoGo_Dismount()
	elseif GOGO_CLASS == "DRUID" and GoGo_IsShifted() then
		GoGo_Dismount()
	elseif GOGO_CLASS == "SHAMAN" and UnitBuff("player", GOGO_SHAMAN_GHOSTWOLF) then
		GoGo_Dismount()
	elseif not InCombatLockdown() then
		GoGo_FillButton(button, GoGo_ChooseMount())
	end --if
	
	if not TESTVERSION then
		if ( IsInGuild() ) then
			SendAddonMessage("GoGoMountVER", GetAddOnMetadata("GoGoMount", "Version"), "GUILD")
		end --if
			SendAddonMessage("GoGoMountVER", GetAddOnMetadata("GoGoMount", "Version"), "BATTLEGROUND")
			SendAddonMessage("GoGoMountVER", GetAddOnMetadata("GoGoMount", "Version"), "RAID")
	end --if
	
end --function

---------
function GoGo_ChooseMount(some_mounts)
---------
	if GOGO_DEBUG then
		DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Choose Mount"))
	end --if

	local mounts = GoGo_FindMounts(some_mounts or GoGo_ChooseMounts())
	if mounts then
		return mounts[math.random(table.getn(mounts))]
	end --if
end --function

---------
function GoGo_ChooseMounts(mounts)
---------
	if GOGO_DEBUG then
		DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Choose Mounts"))
	end --if

	local loc = GetRealZoneText()
	if not mounts then
		if (GOGO_CLASS == "DRUID" or GOGO_CLASS == "SHAMAN") and (GoGo_IsMoving or IsSwimming()) then
			return GOGO_SPELLS
		elseif GoGo_Prefs[loc] then
			if GOGO_DEBUG then
				DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Preferred mounts found"))
			end --if
			return GoGo_Prefs[loc]
		end --if
	end --if
	if mounts == GoGo_Prefs[loc] then
		if loc == "Ahn'Qiraj" then
			return GOGO_BUGS
		elseif GoGo_CanFly() and not GoGo_SkipFlying and (GoGo_InOutlands() or (GoGo_InNorthrend and GoGo_InBook(GOGO_COLD_WEATHER_FLYING))) then
			return GOGO_AIR_FAST
		elseif GoGo_CanRide() then
			return GOGO_LAND_FAST
		elseif GoGo_AllLevelsMount() then
			return GOGO_NORESTRICTION
		else
			return GOGO_SPELLS
		end --if
	elseif mounts == GOGO_BUGS then
		return GOGO_LAND_FAST
	elseif mounts == GOGO_AIR_FAST then
		return GOGO_AIR_SLOW
	elseif mounts == GOGO_AIR_SLOW then
		return GOGO_LAND_FAST
	elseif mounts == GOGO_LAND_FAST then
		return GOGO_LAND_SLOW
	elseif mounts == GOGO_LAND_SLOW then
		return GOGO_NORESTRICTION
	elseif mounts == GOGO_NORESTRICTION then
		return GOGO_SPELLS
	elseif mounts == GOGO_SPELLS then
		return nil
	end --if
end --function

---------
function GoGo_FindMounts(some_mounts, skip)
---------
	local mounts = {}
	if table.getn(some_mounts) > 0 then
		for i, item in ipairs(some_mounts) do
			local name = GoGo_InCompanions(item)
			if name then
				table.insert(mounts, name)
			end --if
		end --for
	end --if
	if some_mounts[GOGO_CLASS] and GoGo_Prefs.checkspells then
		local spell = GoGo_InBook(some_mounts[GOGO_CLASS])
		if spell then
			table.insert(mounts, spell)
		end --if
	end --if
	if table.getn(mounts) > 0 then
		if not GoGo_Prefs.preferflight and some_mounts == GOGO_AIR_SLOW and GoGo_FindMounts(GOGO_LAND_FAST, true) then
			return GoGo_FindMounts(GOGO_LAND_FAST)
		else
			return mounts
		end --if
	elseif skip then
		return nil
	else
		local next_mounts = GoGo_ChooseMounts(some_mounts)
		if next_mounts then
			return GoGo_FindMounts(next_mounts)
		else
			return nil
		end --if
	end --if
end --function

---------
function GoGo_Dismount()
---------
	if IsMounted() then
		Dismount()
	elseif GOGO_CLASS == "DRUID" and GoGo_IsShifted() then
		CancelPlayerBuff(GoGo_IsShifted())
	elseif GOGO_CLASS == "SHAMAN" and UnitBuff("player", GOGO_SHAMAN_GHOSTWOLF) then
		CancelPlayerBuff(GOGO_SHAMAN_GHOSTWOLF)
	else
		return nil
	end --if
	return true
end --function

---------
--function GoGo_InBags(item)
---------
--	for bag = 0, NUM_BAG_FRAMES do
--		for slot = 1, GetContainerNumSlots(bag) do
--			local link = GetContainerItemLink(bag, slot)
--			if link and string.find(link, item) then
--				return GetItemInfo(link)
--			end --if
--		end --for
--	end --for
--end --function

---------
function GoGo_InCompanions(item)
---------
	for slot = 1, GetNumCompanions("MOUNT") do
		local creatureID, creatureName, spellID, icon, active = GetCompanionInfo("MOUNT", slot)
		if spellID and string.find(item, spellID) then
			if GOGO_DEBUG then 
				DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Found " .. GetSpellInfo(spellID)))
			end --if
			return GetSpellInfo(spellID)
		end --if
	end --for
end --function

---------
function GoGo_InBook(spell)
---------
	if type(spell) == "function" then
		return spell()
	else
--		if string.find(spell, "spell:%d+") then
--			spell, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(spell)
--		end --if
		if GOGO_DEBUG then
			DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("InBook searching for " .. spell))
		end --if
		local slot = 1
		while GetSpellName(slot, "spell") do
			local name = GetSpellName(slot, "spell")
			if name == spell then
				return spell
			end --if
			slot = slot + 1
		end --while
	end --if
end --function

---------
function GoGo_IsShifted()
---------
	for i = 1, GetNumShapeshiftForms() do
		local _, name, active = GetShapeshiftFormInfo(i)
		if active then
			return name
		end
	end --for
end --function

---------
function GoGo_CanFly()
---------
	local level = UnitLevel("player")
	if level >=70 then
		return true
	elseif GOGO_CLASS == "DRUID" and level >= 68 then
		return true
	end --if
end --function

---------
function GoGo_CanRide()
---------
	local level = UnitLevel("player")
	if level >= 30 then
		return true
	end --if
end --function

---------
function GoGo_AllLevelsMount()
---------
	local level = UnitLevel("player")
	if level >= 1 then
		return true
	end --if
end --function

---------
function GoGo_InOutlands()
---------
	local loc = GetRealZoneText()
	if string.find(GOGO_OUTLANDS, loc) then
		return true
	end --if
end --function

function GoGo_InNorthrend()
---------
	local loc = GetRealZoneText()
	if string.find(GOGO_NORTHREND, loc) then
		return true
	end --if
end --function

---------
function GoGo_AddPrefMount(spell)
---------
	if GOGO_DEBUG then 
		DEFAULT_CHAT_FRAME:AddMessage(GoGo_Msg("Preference " .. spell))
	end --if

	local loc = GetRealZoneText()
	if not GoGo_Prefs[loc] then GoGo_Prefs[loc] = {} end
	table.insert(GoGo_Prefs[loc], spell)
	if table.getn(GoGo_Prefs[loc]) > 1 then
		local i = 2
		repeat
			if GoGo_Prefs[loc][i] == GoGo_Prefs[loc][i - 1] then
				table.remove(GoGo_Prefs[loc], i)
			else
				i = i + 1
			end --if
		until i > table.getn(GoGo_Prefs[loc])
	end --if
end --function

---------
--function GoGo_AddPrefSpell(spell)
---------
--	local loc = GetRealZoneText()
--	if not GoGo_Prefs[loc] then GoGo_Prefs[loc] = {} end
--	GoGo_Prefs[loc][GOGO_CLASS] = spell
--end --function

---------
function GoGo_FillButton(button, mount)
---------
	if mount then
		button:SetAttribute("macrotext", "/cast "..mount)
	else
		button:SetAttribute("macrotext", nil)
	end --if
end --function

---------
function GoGo_CheckBindings()
---------
	for binding, button in pairs({GOGOBINDING = GoGoButton, GOGOBINDING2 = GoGoButton2}) do
		ClearOverrideBindings(button)
		local key1, key2 = GetBindingKey(binding)
		if key1 then
			SetOverrideBindingClick(button, true, key1, button:GetName())
		end --if
		if key2 then
			SetOverrideBindingClick(button, true, key2, button:GetName())
		end --if
	end --if
end --function

---------
function GoGo_CheckMoving(time)
---------
	local pos = GetPlayerMapPosition("player")
	if pos ~= GoGo_Position then
		GoGo_Position = pos
		GoGo_IsMoving = true
	else
		GoGo_IsMoving = nil
	end --if
end --function

---------
function GoGo_Msg(msg)
---------
	if msg then
		if GOGO_MESSAGES[msg] then
			GoGo_Msg(GOGO_MESSAGES[msg]())
		else
			msg = string.gsub(msg, "<", LIGHTYELLOW_FONT_COLOR_CODE)
			msg = string.gsub(msg, ">", "|r")
			DEFAULT_CHAT_FRAME:AddMessage(GREEN_FONT_COLOR_CODE.."GoGo: |r"..msg)
		end --if
	end --if
end --function

---------
function GoGo_Id(itemstring)
---------
	local _, _, itemid = string.find(itemstring,"(item:%d+)")
	if itemid then
		return itemid.." - "..itemstring
	end --if
	local _, _, spellid = string.find(itemstring,"(spell:%d+)")
	if spellid then
		return spellid.." - "..itemstring
	end --if

end --function

GOGO_AIR_FAST = {  -- Level 70 fast air mounts
	"spell:32246:", "spell:32295:", "spell:32296:", "spell:32297:", -- windriders
	"spell:32242:", "spell:32289:", "spell:32290:", "spell:32292:", "spell:55164:", -- gryphons
	"spell:37015:", "spell:41513:", "spell:41514:", "spell:41515:", "spell:41516:", "spell:41517:", "spell:41518:", "spell:44744:", "spell:49193:", -- netherdrakes
	"spell:60025:", -- drakes
	"spell:39798:", "spell:39800:", "spell:39801:", "spell:39802:", "spell:39803:", -- nether rays
	"spell:44151:", -- engineering machines
	"spell:32345:", "spell:40192:", "item:33338:", "item:35800:",  -- phoenix
	"spell:43927:", -- hippogryphs
	"spell:42668:", -- broom
	"spell:46199:", -- rocket
	"spell:43810:", "spell:51960:",  -- frost wyrms
	"spell:52649:", -- flying carpet
	["DRUID"] = GOGO_DRUID_FAST_FLIGHTFORM,
}

GOGO_AIR_SLOW = {  -- Level 70 slow air mounts
	"spell:32243:", "spell:32244:", "spell:32245:", -- windriders
	"spell:32235:", "spell:32239:", "spell:32240:", -- gryphons
	"spell:44153:",  -- engineering machines
	"spell:42667:",  -- broom
	"spell:46197:", -- rocket
	["DRUID"] = GOGO_DRUID_FLIGHTFORM,
}

GOGO_LAND_FAST = {  -- Level 60 fast land mounts -- 100% speed increase
	"spell:16080:", "spell:16081:", "item:18245:", "spell:22742:", "spell:23250:", "spell:23251:", "spell:23252:", "spell:23509:", -- wolves
	"item:18247:", "spell:18991:", "spell:18992:", "spell:23247:", "spell:23248:", "spell:23249:", "spell:22718:", "spell:49379:", -- kodos
	"spell:16084:", "spell:17450:", "item:18246:", "spell:22721:", "spell:23241:", "spell:23242:", "spell:23243:", "spell:24242:", -- raptors
	"spell:17465:", "item:18248:", "spell:22722:", "spell:23246:", -- skeletals
	"spell:33660:", "spell:35025:", "spell:35027:", "spell:35028:", "spell:46628:",  -- hawks
	"spell:34790:", "spell:34896:", "spell:34897:", "spell:34898:", "spell:34899:", "spell:39315:", "spell:39316:", "spell:39317:", "spell:39318:", "spell:39319:", -- talbuks
	"spell:17460:", "spell:17461:", "item:18244:", "spell:22720:", "spell:23238:", "spell:23239:", "spell:23240:", "spell:43900:", -- rams
	"spell:15779:", "spell:17459:", "item:18243:", "spell:22719:", "spell:23222:", "spell:23223:", "spell:23225:", -- striders
	"spell:43688:", "spell:51412:", "spell:54753:", -- bears
	"spell:16055:", "spell:16056:", "spell:17229:", "spell:22723:", "spell:23219:", "spell:23221:", "item:18242:", "spell:23338:", "spell:42777:", -- sabers
	"spell:16083:", "item:12354:", "item:18241:", "spell:22717:", "spell:23161:", "spell:23214:", "spell:23227:", "spell:23228:", "spell:23229:", "spell:34767:", "spell:36702:", "spell:48025:", "spell:48778:", -- horses
	"spell:17481:", "spell:23510:", "spell:24252:", "spell:26656:", "spell:41252:", -- misc
	"spell:42683:", -- broom
	"spell:35713:", "spell:35712:", "spell:35714:", "spell:48027:",  -- elekks
	"spell:49322:", -- zhevra
	"spell:50281:", -- warp stalker
}

GOGO_LAND_SLOW = {   -- Level 30 slow land mountsm  -- 60% speed increase
	"spell:579:", "spell:580:", "spell:6653:", "spell:6654:", -- wolves
	"item:15277:", "item:15290:", "spell:49378:", "spell:50869:", -- kodos
	"spell:8395:", "spell:10796:", "spell:10799:", -- raptors
	"spell:17462:", "spell:17463:", "spell:17464:", -- skeletals
	"spell:34795:", "spell:35018:", "spell:35020:", "spell:35022:", -- hawks
	"spell:10873:", "spell:10969:", "spell:17453:", "spell:17454:", -- striders
	"spell:10793:", "item:8630:", "spell:8394:", "spell:10789:", "spell:42776:", -- sabers
	"spell:458:", "spell:470:", "spell:472:", "spell:5784:", "spell:6648:", "spell:13819:", "spell:34769:", -- horses
	"spell:6777:", "spell:6899:", "spell:6898:", "spell:43899:", -- rams
	"spell:34406:", "spell:35710:", "spell:35711:", -- elekks
	"spell:42680:", "spell:47977:", -- broom
}

GOGO_NORESTRICTION = {  -- Level 1 mounts
	"spell:30174:", -- turtle
	"spell:42692:", -- broom
}

GOGO_SPELLS = {
	["DRUID"] = function()
		if GoGo_InBook(GOGO_DRUID_AQUAFORM) then
			if not GoGo_SkipFlying and GoGo_InOutlands() and GoGo_InBook(GOGO_DRUID_FAST_FLIGHTFORM) then
				return "[swimming] "..GOGO_DRUID_AQUAFORM.."; [combat]"..GOGO_DRUID_TRAVELFORM.."; "..GOGO_DRUID_FAST_FLIGHTFORM
			elseif not GoGo_SkipFlying and GoGo_InOutlands() and GoGo_InBook(GOGO_DRUID_FLIGHTFORM) then
				return "[swimming] "..GOGO_DRUID_AQUAFORM.."; [combat]"..GOGO_DRUID_TRAVELFORM.."; "..GOGO_DRUID_FLIGHTFORM
			else
				return "[swimming] "..GOGO_DRUID_AQUAFORM.."; "..GOGO_DRUID_TRAVELFORM
			end --if
		end --if
	end, --function
	["SHAMAN"] = GOGO_SHAMAN_GHOSTWOLF,
}

GOGO_BUGS = {
	"spell:25953:", "spell:26054:", "spell:26055:", "spell:26056:", "spell:26656:", 
}

GOGO_ERRORS = {
	[SPELL_FAILED_NOT_MOUNTED] = true,
	[SPELL_FAILED_NOT_SHAPESHIFT] = true,
	[ERR_ATTACK_MOUNTED] = true,
}

GOGO_COMMANDS = {
	["spell"] = function()
		GoGo_Prefs.checkspells = not GoGo_Prefs.checkspells
		GoGo_Msg("spell")
		GoGo_Settings_Update()
	end, --function
	["auto"] = function()
		GoGo_Prefs.autodismount = not GoGo_Prefs.autodismount
		GoGo_Msg("auto")
		GoGo_Settings_Update()
	end, --function
	["fly"] = function()
		if not GoGo_CanFly() then
			return
		else
			GoGo_Prefs.preferflight = not GoGo_Prefs.preferflight
			GoGo_Msg("fly")
			GoGo_Settings_Update()
		end --if
	end, --function
	["clear"] = function()
		GoGo_Prefs[GetRealZoneText()] = nil
		if not InCombatLockdown() then
			for i, button in ipairs({GoGoButton, GoGoButton2}) do
				GoGo_FillButton(button)
			end --for
		end --if
		GoGo_Msg("pref")
	end, --function
	["disableupdatenotice"] = function()
		GoGo_Prefs.DisableUpdateNotice = not GoGo_Prefs.DisableUpdateNotice
		GoGo_Msg("disableupdatenotice")
		GoGo_Settings_Update()
	end, --function
}

GOGO_MESSAGES = {
	["spell"] = function()
		if GoGo_Prefs.checkspells then
			return "Forms included - </gogo spell> to toggle"
		else
			return "Forms excluded - </gogo spell> to toggle"
		end --if
	end, --function
	["auto"] = function()
		if GoGo_Prefs.autodismount then
			return "Autodismount active - </gogo auto> to toggle"
		else
			return "Autodismount inactive - </gogo auto> to toggle"
		end --if
	end, --function
	["fly"] = function()
		if not GoGo_CanFly() then
			return
		elseif GoGo_Prefs.preferflight then
			return "Slow flying over fast running - </gogo fly> to toggle"
		else
			return "Fast running over slow flying - </gogo fly> to toggle"
		end --if
	end, --function
	["pref"] = function()
		local loc = GetRealZoneText()
		local list = ""
		if GoGo_Prefs[loc] then
			list = list..table.concat(GoGo_Prefs[loc], ", ")
			if GoGo_Prefs[loc][GOGO_CLASS] then
				if string.len(list) > 0 then
					list = list..", "
				end --if
				list = list..GoGo_Prefs[loc][GOGO_CLASS]
			end --if
			return loc..": "..list.." - </gogo clear> to clear"
		else
			return loc..": ?".." - </gogo ItemLink> or </gogo SpellName> to add"
		end --if
	end, --function
	["disableupdatenotice"] = function()
		if GoGo_Prefs.DisableUpdateNotice then
			return "Update notices from other players disabled - </gogo disableupdatenotice> to toggle"
		else
			return "Update notices from other players enabled - </gogo disableupdatenotice> to toggle"
		end --if
	end, --function
}

---------
function GoGo_Panel_OnLoad(GoGo_Panel)
---------
	GoGo_Panel.name = "GoGoMount"
	GoGo_Panel.okay = function (self) GoGo_Panel_Okay(); end;
	GoGo_Panel.default = function (self) GoGo_Settings_Default(); GoGo_Settings_Update(); end;
	InterfaceOptions_AddCategory(GoGo_Panel)
	
	
	GoGo_Panel_IncludeShapeFormSpells = CreateFrame("CheckButton", "GoGo_Panel_IncludeShapeFormSpells", GoGo_Panel, "OptionsCheckButtonTemplate")
	GoGo_Panel_IncludeShapeFormSpells:SetPoint("TOPLEFT", 16, -16)
	GoGo_Panel_IncludeShapeFormSpellsText:SetText("Include shape shift forms")

	GoGo_Panel_AutoDismount = CreateFrame("CheckButton", "GoGo_Panel_AutoDismount", GoGo_Panel, "OptionsCheckButtonTemplate")
	GoGo_Panel_AutoDismount:SetPoint("TOPLEFT", "GoGo_Panel_IncludeShapeFormSpells", "BOTTOMLEFT", 0, -4)
	GoGo_Panel_AutoDismountText:SetText("Enable automatic dismount")

	if GoGo_CanFly() then
		GoGo_Panel_PreferFlight = CreateFrame("CheckButton", "GoGo_Panel_PreferFlight", GoGo_Panel, "OptionsCheckButtonTemplate")
		GoGo_Panel_PreferFlight:SetPoint("TOPLEFT", "GoGo_Panel_AutoDismount", "BOTTOMLEFT", 0, -4)
		GoGo_Panel_PreferFlightText:SetText("Prefer slow air mount over fast ground mount")
	end --if
	
	GoGo_Panel_DisableUpdateNotice = CreateFrame("CheckButton", "GoGo_Panel_DisableUpdateNotice", GoGo_Panel, "OptionsCheckButtonTemplate")
	if GoGo_CanFly() then
		GoGo_Panel_DisableUpdateNotice:SetPoint("TOPLEFT", "GoGo_Panel_PreferFlight", "BOTTOMLEFT", 0, -4)
	else
		GoGo_Panel_DisableUpdateNotice:SetPoint("TOPLEFT", "GoGo_Panel_AutoDismount", "BOTTOMLEFT", 0, -4)
	end --if
	GoGo_Panel_DisableUpdateNoticeText:SetText("Disable Update Notices")

end --function

---------
function GoGo_Settings_Update()
---------
	GoGo_Panel_IncludeShapeFormSpells:SetChecked(GoGo_Prefs.checkspells)
	GoGo_Panel_AutoDismount:SetChecked(GoGo_Prefs.autodismount)
	if GoGo_CanFly() then GoGo_Panel_PreferFlight:SetChecked(GoGo_Prefs.preferflight) end --if
	GoGo_Panel_DisableUpdateNotice:SetChecked(GoGo_Prefs.DisableUpdateNotice)

	if GoGo_Prefs.autodismount then
		GoGoFrame:RegisterEvent("UI_ERROR_MESSAGE")
	else
		GoGoFrame:UnregisterEvent("UI_ERROR_MESSAGE")
	end --if

end -- function

---------
function GoGo_Panel_Okay()
---------
	GoGo_Prefs.checkspells = GoGo_Panel_IncludeShapeFormSpells:GetChecked()
	GoGo_Prefs.autodismount = GoGo_Panel_AutoDismount:GetChecked()
	if GoGo_CanFly() then GoGo_Prefs.preferflight = GoGo_Panel_PreferFlight:GetChecked() end --if
	GoGo_Prefs.DisableUpdateNotice = GoGo_Panel_DisableUpdateNotice:GetChecked()
	
end --function

---------
function GoGo_Settings_Default()
---------
	GoGo_Prefs.version = GetAddOnMetadata("GoGoMount", "Version")
	GoGo_Prefs.checkspells = true
	GoGo_Prefs.autodismount = true
	GoGo_Prefs.preferflight = true
	GoGo_Prefs.DisableUpdateNotice = false

end --function
